%define docs 1

Name: gforth
%define Name GNU Forth
Version: 0.6.2
Release: alt5
License: GPL
Group: Development/Other
Summary: GNU implementation of the ANS Forth language
Summary(uk_UA.CP1251): GNU-   ANS Forth
Summary(ru_RU.CP1251): GNU-   ANS Forth
URL: http://www.jwdt.com/~paysan/gforth.html
Source0: %name-%version.tar.bz2
Source1: %{name}_16x16.png
Source2: %{name}_32x32.png
Source3: %{name}_48x48.png
Patch0: %name-0.6.2-doc.patch.gz
Patch1: %name-0.6.2-debug.diff.gz

# Automatically added by buildreq on Mon Jan 30 2006
%ifdef docs
BuildRequires: tetex-core tetex-dvips tetex-latex
%endif

%description
%Name is a fast and portable implementation of the ANS Forth language. It
works nicely with the Emacs editor, offers some nice features such as input
completion and history, backtraces, a decompiler and a powerful locals facility.
Gforth combines traditional implementation techniques with newer techniques for
portability and performance: its inner intnerpreter is direct threaded with
several optimizations, but you can also use a traditional-style indirect threaded
interpreter.

%description -l uk_UA.CP1251
%Name -       ANS Forth. ³
    Emacs,    ,  
   ,  ,    
.     Gforth   
  :    -   
,       
.

%description -l ru_RU.CP1251
%Name -       ANS Forth.
     Emacs,    ,
     ,  ,   
 .     Gforth 
    :    -  
 ,      
 .


%ifdef docs
%package doc-info
Group: Development/Other
Summary: Documentation for the %Name in Info format

%description doc-info
%Name is a fast and portable implementation of the ANS Forth language. It
works nicely with the Emacs editor, offers some nice features such as input
completion and history, backtraces, a decompiler and a powerful locals facility.
Gforth combines traditional implementation techniques with newer techniques for
portability and performance: its inner intnerpreter is direct threaded with
several optimizations, but you can also use a traditional-style indirect threaded
interpreter.

This package contains documentation for the %Name in Info format.

%description doc-info -l uk_UA.CP1251
%Name -       ANS Forth. ³
    Emacs,    ,  
   ,  ,    
.     Gforth   
  :    -   
,       
.

     %Name   Info.

%description doc-info -l ru_RU.CP1251
%Name -       ANS Forth.
     Emacs,    ,
     ,  ,   
 .     Gforth 
    :    -  
 ,      
 .

     %Name   Info.


%package doc-ps
Group: Development/Other
Summary: Documentation for the %Name in Postscript format

%description doc-ps
%Name is a fast and portable implementation of the ANS Forth language. It
works nicely with the Emacs editor, offers some nice features such as input
completion and history, backtraces, a decompiler and a powerful locals facility.
Gforth combines traditional implementation techniques with newer techniques for
portability and performance: its inner intnerpreter is direct threaded with
several optimizations, but you can also use a traditional-style indirect threaded
interpreter.

This package contains documentation for the %Name in Postscript format.

%description doc-ps -l uk_UA.CP1251
%Name -       ANS Forth. ³
    Emacs,    ,  
   ,  ,    
.     Gforth   
  :    -   
,       
.

     %Name   Postscript.

%description doc-ps -l ru_RU.CP1251
%Name -       ANS Forth.
     Emacs,    ,
     ,  ,   
 .     Gforth 
    :    -  
 ,      
 .

     %Name   Postscript.


%package doc-html
Group: Development/Other
Summary: Documentation for the %Name in HTML format

%description doc-html
%Name is a fast and portable implementation of the ANS Forth language. It
works nicely with the Emacs editor, offers some nice features such as input
completion and history, backtraces, a decompiler and a powerful locals facility.
Gforth combines traditional implementation techniques with newer techniques for
portability and performance: its inner intnerpreter is direct threaded with
several optimizations, but you can also use a traditional-style indirect threaded
interpreter.

This package contains documentation for the %Name in HTML format.

%description doc-html -l uk_UA.CP1251
%Name -       ANS Forth. ³
    Emacs,    ,  
   ,  ,    
.     Gforth   
  :    -   
,       
.

     %Name   HTML.

%description doc-html -l ru_RU.CP1251
%Name -       ANS Forth.
     Emacs,    ,
     ,  ,   
 .     Gforth 
    :    -  
 ,      
 .

     %Name   HTML.


%package doc-dvi
Group: Development/Other
Summary: Documentation for the %Name in DVI format

%description doc-dvi
%Name is a fast and portable implementation of the ANS Forth language. It
works nicely with the Emacs editor, offers some nice features such as input
completion and history, backtraces, a decompiler and a powerful locals facility.
Gforth combines traditional implementation techniques with newer techniques for
portability and performance: its inner intnerpreter is direct threaded with
several optimizations, but you can also use a traditional-style indirect threaded
interpreter.

This package contains documentation for the %Name in DVI format.

%description doc-dvi -l uk_UA.CP1251
%Name -       ANS Forth. ³
    Emacs,    ,  
   ,  ,    
.     Gforth   
  :    -   
,       
.

     %Name   DVI.

%description doc-dvi -l ru_RU.CP1251
%Name -       ANS Forth.
     Emacs,    ,
     ,  ,   
 .     Gforth 
    :    -  
 ,      
 .

     %Name   DVI.


%package doc-txt
Group: Development/Other
Summary: Documentation for the %Name in HTML format

%description doc-txt
%Name is a fast and portable implementation of the ANS Forth language. It
works nicely with the Emacs editor, offers some nice features such as input
completion and history, backtraces, a decompiler and a powerful locals facility.
Gforth combines traditional implementation techniques with newer techniques for
portability and performance: its inner intnerpreter is direct threaded with
several optimizations, but you can also use a traditional-style indirect threaded
interpreter.

This package contains documentation for the %Name in ASCII text format.

%description doc-txt -l uk_UA.CP1251
%Name -       ANS Forth. ³
    Emacs,    ,  
   ,  ,    
.     Gforth   
  :    -   
,       
.

     %Name   ASCII .

%description doc-txt -l ru_RU.CP1251
%Name -       ANS Forth.
     Emacs,    ,
     ,  ,   
 .     Gforth 
    :    -  
 ,      
 .

     %Name   ASCII .


%package doc-pdf
Group: Development/Other
Summary: Documentation for the %Name in PDF format

%description doc-pdf
%Name is a fast and portable implementation of the ANS Forth language. It
works nicely with the Emacs editor, offers some nice features such as input
completion and history, backtraces, a decompiler and a powerful locals facility.
Gforth combines traditional implementation techniques with newer techniques for
portability and performance: its inner intnerpreter is direct threaded with
several optimizations, but you can also use a traditional-style indirect threaded
interpreter.

This package contains documentation for the %Name in PDF format.

%description doc-pdf -l uk_UA.CP1251
%Name -       ANS Forth. ³
    Emacs,    ,  
   ,  ,    
.     Gforth   
  :    -   
,       
.

     %Name   PDF.

%description doc-pdf -l ru_RU.CP1251
%Name -       ANS Forth.
     Emacs,    ,
     ,  ,   
 .     Gforth 
    :    -  
 ,      
 .

     %Name   PDF.
%endif


%prep
%setup -q
%patch0 -p1
%patch1 -p0
rm -f doc/{*.ps,*.info*}


%build
# -mtune=pentium4 lead to compile error, using -mtune=pentium3 instead
%remove_optflags -mtune=pentium4
%add_optflags -fno-reorder-blocks
#add_optflags -mtune=pentium3

%configure --enable-force-reg
%make_build

%ifdef docs
%make info txt html ps TAGS doc/vmgen.pdf
rm -f doc/%name.{aux,cp,fn,ky,log,pg,tp,vr}
%make doc/%name.pdf || :
%else
%make info TAGS
%endif


%install
%define docdir %_docdir/%name-%version
install -d %buildroot{%_datadir/emacs/site-lisp,%docdir}
install -m 0644 %name.el %buildroot%_datadir/emacs/site-lisp/
%makeinstall
rm -f %buildroot%_infodir/dir
ln -s %name.1 %buildroot%_man1dir/%name-fast.1
ln -s %name.1 %buildroot%_man1dir/%{name}mi.1
bzip2 --best -c ChangeLog > %buildroot%docdir/ChangeLog.bz2
install -m 0644 AUTHORS BUGS Benchres NEWS* README* ToDo %buildroot%docdir/
%ifdef docs
install -m 0644 doc/*.{ps,html,dvi,txt,pdf} %buildroot%docdir/
%endif

# fixing pathes
pushd %buildroot%_bindir
for f in *-%version; do
    mv -f $f `basename $f -%version`
done
cd %buildroot%_datadir/%name/%version/arch
mv 386 i386
popd
#

# icons
install -d %buildroot{%_iconsdir,%_miconsdir,%_liconsdir}
install -m 0644 %SOURCE1 %buildroot/%_miconsdir/%name.png
install -m 0644 %SOURCE2 %buildroot/%_iconsdir/%name.png
install -m 0644 %SOURCE3 %buildroot/%_liconsdir/%name.png

#menu
%ifdef _desktopdir
install -d %buildroot%_desktopdir
iconv -f cp1251 -t utf-8 > %buildroot%_desktopdir/%name.desktop <<__MENU__
[Desktop Entry]
Encoding=UTF-8
GenericName=Gforth
Name=%Name shell
Name[uk]=%Name 
Name[ru]=%Name 
Exec=%name
Icon=%name.png
Type=Application
Terminal=true
Categories=Application;Development;
__MENU__
%else
install -d %buildroot%_menudir
cat >%buildroot%_menudir/%name <<__MENU__
?package(%name):command="%_bindir/%name" \
icon="%name.png"  needs="text" section="%group" \
title="Gforth" longtitle="%Name - Shell"
__MENU__
%endif


%post
%update_menus
%ifndef docs
%install_info %name.info
%install_info vmgen.info
%endif


%ifndef docs
%preun
%uninstall_info %name.info
%uninstall_info vmgen.info
%endif


%postun
%clean_menus


%ifdef docs
%post doc-info
%install_info %name.info
%install_info vmgen.info


%preun doc-info
%uninstall_info %name.info
%uninstall_info vmgen.info
%endif


%files
%dir %docdir
%docdir/AUTHORS
%docdir/BUGS
%docdir/Benchres
%docdir/ChangeLog*
%docdir/NEWS*
%docdir/README*
%docdir/ToDo
%_bindir/*
%_libdir/%name
%_datadir/%name
%_datadir/emacs/site-lisp/%name.el
%_man1dir/*
%ifndef docs
%_infodir/*
%endif
%_iconsdir/%name.png
%_liconsdir/%name.png
%_miconsdir/%name.png
%ifdef _desktopdir
%_desktopdir/*
%else
%_menudir/*
%endif


%ifdef docs
%files doc-info
%_infodir/*


%files doc-ps
%dir %docdir
%docdir/*.ps


%files doc-html
%dir %docdir
%docdir/*.html


%files doc-dvi
%dir %docdir
%docdir/*.dvi


%files doc-txt
%dir %docdir
%docdir/*.txt


%files doc-pdf
%dir %docdir
%docdir/*.pdf
%endif


%changelog
* Thu Mar 30 2006 Led <led@altlinux.ru> 0.6.2-alt5
- fixed %%changelog

* Mon Mar 27 2006 Led <led@altlinux.ru> 0.6.2-alt4
- fixed spec
- removed -mtune=pentium4 from %%optflags

* Fri Feb 17 2006 Led <led@altlinux.ru> 0.6.2-alt3
- apdeted %name-0.6.2-doc.patch

* Fri Feb 03 2006 Led <led@altlinux.ru> 0.6.2-alt2
- added 0.6.2-debug.diff

* Mon Jan 30 2006 Led <led@altlinux.ru> 0.6.2-alt1
- initial build
